import './OCST.scss';
import {PageManager} from '@mvps-genesis/bootstrap';
import ConfirmAction from 'extensions/confirm-action';
import {SummaryEvents} from 'extensions/checkout-pages';

export default class OCST extends PageManager {

	constructor (pageContext) {

		super(pageContext);

	}

	onReady () {
		new ConfirmAction('.js-confirm-exit', {
			message: 'Are you sure you want to exit checkout?',
			redirectUrl: this.pageContext.Basket_Url
		});

		new SummaryEvents();

		this.initPromoCodeEvents();
	}

	async initPromoCodeEvents () {

		const promoCodeContainers = document.getElementsByClassName('g-checkout__order-summary-promo-form');

		if (!promoCodeContainers.length) {
			return;
		}

		const {PromoCodeEvents} = await import('extensions/checkout-pages');

		for (const promoCodeContainer of promoCodeContainers) {
			const input = promoCodeContainer.querySelector('input[type=text]');
			const submitElement = promoCodeContainer.querySelector('[type=submit]');

			if (input && submitElement) {
				new PromoCodeEvents(input, submitElement);
			}
		}

	}

}
