import './ORDL.scss';
import {PageManager} from '@mvps-genesis/bootstrap';

export default class ORDL extends PageManager {

	constructor (pageContext) {
		super(pageContext);
	}

	onReady () {
		this.initFormToggles();
	}

	initFormToggles () {
		const primaryToggleName = 'js-primary-toggle';
		const primaryFormElement = document.getElementById(primaryToggleName);
		const primaryFormControl = document.getElementById(`${primaryToggleName}-control`);

		const secondaryToggleName = 'js-secondary-toggle';
		const secondaryFormElement = document.getElementById(secondaryToggleName);
		const secondaryFormControl = document.getElementById(`${secondaryToggleName}-control`);

		if (!primaryFormElement || !primaryFormControl || !secondaryFormElement || !secondaryFormControl) {
			return;
		}

		const primaryForm = {
			control: primaryFormControl,
			element: primaryFormElement
		};

		const secondaryForm = {
			control: secondaryFormControl,
			element: secondaryFormElement
		};

		primaryFormControl.addEventListener('click', (event) => {
			event.preventDefault();

			this.toggleForms(primaryForm, secondaryForm);
		});

		secondaryFormControl.addEventListener('click', (event) => {
			event.preventDefault();

			this.toggleForms(secondaryForm, primaryForm);
		});
	}

	toggleForms (showForm, hideForm) {
		const showFormClass = 'g-login-register-page__toggle--open';

		hideForm.element.classList.remove(showFormClass);
		hideForm.control.setAttribute('aria-expanded', 'false');
		hideForm.control.classList.remove('u-hidden');
		hideForm.control.focus();

		showForm.control.classList.add('u-hidden');
		showForm.control.setAttribute('aria-expanded', 'true');
		showForm.element.classList.add(showFormClass);
	}
};
